UNIT PP;
INTERFACE {$F+}

USES  Dialogs, FUNG, VENMENU, inpout, tipos, pru, uGlMemo, uPresen, uPresen2,
      ppgraph, Ggraphic, GPMenus; {Delphi 9.2.2001, 4.6.2001}
{NUCLEO/ abstraction}
var
pp_buff: string;
_errcod: integer;

PROCEDURE DISFEL; (* escribir la FEL *)
procedure stat;   (*escribe estadisticas standard*)
procedure _menu;
procedure replic;
procedure menu;
procedure _trace; (*ve si hay que poner o quitar trace y llama menu*)
procedure _exfel; (* extr. primero de fel *)
procedure _act(m:integer;b:boolean); (* actual.estadisticas lista m *)
procedure _agr(m:integer;q:_pl;p:char);(* agreg.a listai m, posi.p *)
procedure _inter(m:integer;_px,_pa,_pu:_pl); (* interc. _pa,,_pu *)
procedure _exal(q:_pl);(* exam. de listai ap.por q;apun.p al sig.*)
procedure _exalo(q:_pl);(* exam. de listai ap.por q;apun.p al sig.*)
procedure _extr(var q:_pl;m:integer);(* extr.de listai m,ap.por q *)
procedure _tran(bex:boolean; m,n:integer; p:char; apor,apde:_pl);
procedure _exlx(var q:_pl; m:integer);
procedure _copy(p:_pl;m:integer;aob:char;apdes:_pl);
procedure _sinc(m,n:integer); (* hace lista sincr.por cond.log.n  *)
                              (* busca hasta m o nil              *)
procedure tab(x:real;j:integer);
procedure _eul(m,n:integer);
procedure _rk4(m,n:integer);
procedure _rkf(m,n:integer);
procedure _sort(m:integer; var x,o_x:real; c:char);
{procedure _graph(tg:char; nv:integer; col:byte; var nomv:_arrnv;
  var minv,maxv:_arrev;var colv:_arrcv; var f1,f2:_arrfo; var x:_arrev);
 llevada a vemenu o a ggraphic o sola en ppgraph}
procedure _iniass(list:integer); (*inicializar SINCHR or ASSEMBLE*)
procedure _exaprisi;
procedure _ilimess(list:integer);
procedure _inici; (*inicializar opcion I del menu de entrada y salida*)

IMPLEMENTATION

PROCEDURE DISFEL; (* escribir la FEL *)
{d95 Escribe siempre a file. Se elimino parametro bscr}
VAR _PY:_PFEL;
BEGIN
if not _bt then begin
                  AssignFile(_ftra,'$CON2'); Rewrite(_ftra); _nftr:='$CON2';
                end; //Delphi 4.6.2001
begin  WRITELN(_ftra);
                     WRITELN(_ftra,'Future Event List at Time',TIME:8:3);
              end;
 _PY:=_FF;
 IF _PY=NIL THEN  WRITELN(_ftra, 'Future Event List Empty');
 WHILE _PY<>NIL DO
 BEGIN
            begin
               WRITE(_ftra,'NODE ',_NNO[_PY^.N]:12,'     T ',_PY^.T:8:3,
               '  IND  ',_PY^.I:4,'  EVP    ',_PY^.EVP:4);
               if _PY^.SU then WRITELN(_ftra,'  BLOCKED')
                          else WRITELN(_ftra);     {1998}
            end;
  _PY:=_PY^.P;

 END;
 WRITELN(_ftra);
 if not _bt then begin
                   CloseFile(_ftra);
                   VerArchivoTrazado(_nftr);
                 end; //Delphi 4.6.2001
 END;

procedure _iniass(list:integer); (*inicializar SINCHR or ASSEMBLE*)
begin
 _ac1:=_acc; sync:=false; _pu:=_fl[list];
end;

procedure _exaprisi;
begin _aas:=false; _exal(_pu); _uprv(_pu^.r,_pu^.b);
end;

procedure _ilimess(list:integer);
begin _extr(_pu,list); _elim(_pu^.r,_pu^.b,_pu);
end;

procedure _inici; (*inicializar opcion I del menu de entrada y salida*)
begin
{Delphi multig; 22.03.2001} _Windowsize:=false; _Comenzando:=true;
 _bsc:=false;
 _REP:=FALSE;   (*equivale a 'I'*)
 fung.inisem;   (*inicializar semillas de numeros aleatorios*)
 _ut:=' ';
 if title=' ' then title:='Basic Experiment';
 (* {2001}_nomars:='$CON1';
 {d95 Pasado aqui desde STAT 1.11.00} AssignFile(_ars,_nomars); rewrite(_ars);*)
 _nftr:='$CON2';
 _outf:='$CON3'; 
 _inieli; _com;
 clrstat;
{d95} ModoInterrupcion(True);
 _init;
end;



PROCEDURE STAT;
(*escribir estadisticas*)
label 1; (*escribir datos de nodos *)

var _i,_j,_k,_m,_cl,_r:integer;_vm,_d,_dp,_t1,_rr,_tps:real;
    _bd:boolean;

procedure rncien(v:real); (*reduce a notacion decimal o exponencial *)
var n,k:integer; sg,sv:char; w:real;
begin  n:=0; sg:='+';
if v>=0 then sv:=' ' else begin sv:='-'; v:=-v end;
w:=v;
if (v=0.0)
 then write(_ars,sv,v:7:1)
 else
  begin
   if v<1
    then
     if v>= 0.01
      then write(_ars,sv,v:7:5)
      else
       begin
        repeat
         v:=v*10; n:=n+1;
        until v>=1;
        k:=round(v*100) ; if k=1000 then k:=999;
        n:=n-1; if n>0 then sg:='-';
        write(_ars,sv,'.',k:3,sg,n:2)
       end
    else
     begin
      repeat
       v:=v/10; n:=n+1;
      until v<=1;
      if n<=5 then
      case n of
       1:write(_ars,sv,w:7:5);
       2:write(_ars,sv,w:7:4);
       3:write(_ars,sv,w:7:3);
       4:write(_ars,sv,w:7:2);
       5:write(_ars,sv,w:7:1);
      end
      else
      begin
       k:=round(v*1000); if k=1000 then k:=999;
       write(_ars,sv,'.',k:3,sg,n:2)
      end
     end;
  end;
 end; {rncien}

procedure wr(i:integer); (*escribir resultados *)
begin
 if _t<>0.0 then _d:=(_l2^[i]-_t*_lp^[i]*_lp^[i])/_t else _d:=0.0;
 if _d<0.0 then _d:=0.0 else _d:=sqrt(_d);
 if _en^[i]>0 then _dp:=(_tp2^[i]-_en^[i]*_tpp^[i]*_tpp^[i])/_en^[i]
             else _dp:=0.0;
 if _dp<0.0  then _dp:=0.0 else _dp:=sqrt(_dp);
 write(_ars,'      ',_en^[i]:6,_l^[i]:5,_lm^[i]:6);
  rncien(_lp^[i]);
  rncien(_d);
  rncien(_mtp^[i]);
  IF _EN^[I]=0 THEN _TPP^[I]:=0.0;
  rncien(_tpp^[i]);
  rncien(_dp);
  rncien(_tl^[i]); writeln(_ars);  {CARLOS 18.10.96}
  end;

procedure _freq; (* escribir tablas de frecuencia *)
var i,j,k,fr,tot,mf:longint; vari:string[12]; cl,h,frr:real; {29/11/2000}
    kf:integer;                                    {29/11/2000}
    b:boolean; chc,ch1:char;
    MessTabla: string;
label 1,2;
procedure hist(h:integer); (* escribir linea de histograma *)
var i: integer;
{chg:=chr(220);}
begin
 h:=h*44 div mf; (* escala *)
 {gotoxy(35,wherey);} for i:=1 to 2 do write(_ars,' ');
 for i:=1 to h do write(_ars,chr(130 {220}));
end;

var sjvar: string[5];
begin
2: {append(_ars);  delphi 12.6.2001}

if _n_fv[1]='_VFA' then
begin
   inpout._WarningDlg('No tables defined');
  goto 1
end;

(*for j:=1 to _n_tab do writeln(_ars,{Delphi 12.6.2001}j:4,'   ',_n_fv[j]);*)
{Delphi 12.6.2001 comienzo} MessTabla:='';
for j:=1 to _n_tab do begin
                        str(j:4,sjvar);
                        MessTabla:=MessTabla+sjvar+': '+_n_fv[j];
                      end;
{write('Number of variable? ( 0 for quit ) '); readln(ch1);}
{dp} sjvar:=InputBox('Variable number',MessTabla+'  0 for quit','0');
val(sjvar,j,kf);


if (j<=0) or (kf=1) then goto 1;
if j>_n_tab then begin {Delphi 16.5.2001 writeln}
                   MessageDlg('Variable not tabulated',mtWarning,[mbOK],0);
 goto 2 end;
{CLRSCR; }
tot:=0; mf:=-32767; k:=trunc(_df[j,2]);
for i:=1 to k do  (* hallar total y maximo *)
 begin tot:=tot+_fr[j,i];
  if _fr[j,i]>mf then mf:=_fr[j,i]
 end;
if tot<>0 then
begin
(* escribir tabla e histograma *)
 writeln(_ars);
 writeln(_ars,'Table ',_n_ft[j],' of variable ',_n_fv[j]);
 writeln(_ars);
 writeln(_ars,' Interval         Freq. Rel.Fr. '); writeln(_ars);
 fr:=_fr[j,1];
 write(_ars,'      ..<',_df[j,1]:6:2,fr:6,fr/tot:8:3); hist(fr);
 writeln(_ars);
 cl:=_df[j,1]; h:=_df[j,3];
 for i:=2 to k-1 do
  begin fr:=_fr[j,i];
   write(_ars,cl:6:2,'..<',cl+h:6:2,fr:6,fr/tot:8:3); hist(fr);
   cl:=cl+h;WRITELN(_ars);
  end;
 fr:=_fr[j,k];
 write(_ars,'       >=',CL:6:2,fr:6,fr/tot:8:3);
 hist(fr);
 writeln(_ars);
 writeln(_ars,'Total          ',tot:6,1.000:8:3);
 {_ch:=readkey; inpout._WinPause;}
 UnMensaje('Frequency Tables');    //Delphi 12.6.2001  comienzo
 WRITELN(_ARS); CLOSE(_ARS);
 VerArchivoSalida(_nomars); Append(_ARS); //Delphi 12.6.2001 fin
 {writeln(_ars);
 close(_ars); }
 goto 2;
end
else writeln(_ars,'No values tabulated');
1:end;

begin                               (*************** del STAT *)
{d95} ModoInterrupcion(False);

{Delphi 2001} (*if _rep then
              if (not _est or (nrep=1)) then
              begin AssignFile(_ars,'$CON1');
                    rewrite(_ars);
              end
              else rewrite(_ars); *) {Hay que cosultar si abierto o no !!}
{multg 2001  rewrite(_ars); }
if _bt then begin Close(_ftra);  {Delphi 3.6.2001 comienza}
                        VerArchivoTrazado(_nftr);
                  end;  {Delphi 3.6.2001 fin} 

gettime(_hof,_mif,_sef,_def);
fung._intime;                      (*calcular duracion simulacion*)
(*registrar fecha y hora*)
getdate(_an,_mes,_dia,_diase); gettime(_ho,_mini,_seg,_s100);
 _bmen:=false; _t:=time-_tces;
(* actualizar estadisticas de colas *)
for _i:=1 to _n_list do
begin
 _t1:=time-_hc^[_i]; _r:=_l^[_i]; _la^[_i]:=_la^[_i]+_t1*_r;
 _l2^[_i]:=_l2^[_i]+_t1*_r*_r;
 if _t<>0 then _lp^[_i]:=_la^[_i]/_t else _lp^[_i]:=0.0;
 if _l^[_i]=0 then _tl^[_i]:=_tl^[_i]+_t1;
(* para est. de espera de encolados revisar cada cola
 la actual estadistica es de los salidos *)
_hc^[_i]:=time
end;

(* actualizar estadisticas de variables *)
_aesva; (* pasar valores actuales a _vas *)
for _m:=1 to _n_vest do
 begin _t2[_m]:=time-_hcv[_m];
  _sv[_m]:=_sv[_m]+_vas[_m] *_t2[_m];
  _s2v[_m]:=_s2v[_m]+_vas[_m]*_vas[_m]*_t2[_m];
  _hcv[_m]:=time
 end;

{dp assign(_ars,'CON');
 Pasado a _inici AssignFile(_ars,_nomars);  rewrite(_ars); }
_repi:=false;  (*la primera vez no consulta archivo*)

REPEAT      (* ciclo de estadisticas de colas de nodos mientras Repeat*)
  QUIT1:=FALSE;
  if _repi then
  begin
   {writeln; write('Name of output file (CON for Screen; LPT1 Printer):');}
   {readln(_nomars);}
   {dp_nomars:=InputBox('Name for Output file','CON for Window',
                          'CON');
   for _ii:=1 to length(_nomars) do _nomars[_ii]:=upcase(_nomars[_ii]);}

   {dp} {if _nomars='CON' then  AssignFile(_ars,_nomars); else
                              {assign(_ars,_nomars);  rewrite(_ars);
                              Ya esta asignado en _inici}
  end;

if _n_es<>0 then
begin
 _i:=1;
 _encsal;
 _cl:=2;
 while _i<=_n_es do
  begin   writeln(_ars,_ou[_i].nom);
   if _ou[_i].el>0 then             (* es nodo G L E R O *)
    begin
     for _k:=1 to _ou[_i].ind do
      begin
       write(_ars,_k:4); write(_ars,' ','EL'); wr(_ou[_i].el+_k-1);
       if _ou[_i].il>0 then
        begin
         write(_ars,'     ','IL'); wr(_ou[_i].il+_k-1);
        end;
       if _ou[_i].il<0 then  (* es nodo E escribir Tm en syst. *)
        begin
         write(_ars,'  Time in System: Mean ');_j:=-_ou[_i].il+_k-1;
         _cl:=_cl+2;
         _rr:=_en^[_ou[_i].el+_k-1];
         if _rr<>0 then
         begin _tps:=_tmps[_j]/_rr;
           rncien(_tps);
          _d:=(_t2ps[_j]-_rr*_tps*_tps)/_rr;
          if _d<=0 then _d:=0.0 else _d:=sqrt(_d);
          write(_ars,'   Dev. '); rncien(_d);
          write(_ars,'   Max. '); rncien(_txps[_j]);
          write(_ars,'   Min. '); rncien(_tips[_j]);
          writeln(_ars);
         end
         else writeln(_ars);
        end;
     end ;
    end (* del if then *)
    else                          (* es nodo I o D *)
      case _ou[_i].el of
       -2: for _k:=1 to _ou[_i].ind do   (*es nodo I *)
            begin
            writeln(_ars,_k:4,' # Gen. ',_nulle[_ou[_i].il+_k-1]:7);
           end;
       -1: begin    (* es nodo D *)
           _j:=1;  _bd:=true;
           while (_j<= _ou[_i].il) and _bd do  (* para los ele.de arr.suc *)
            begin
            if _ou[_i+_j].el = -1
             then  (* antecesor L ; una lista por indice del L *)
              begin writeln(_ars,'     ',_ou[_i+_j].nom); (* nomb. del ant.*)
               for _k:=1 to _ou[_i+_j].ind do
               begin
                write(_ars,_k:7); wr(_ou[_i+_j].il+_k-1)
               end
              end
             else (* antecesor G I R  *)
              begin
               for _m:=1 to _ou[_i].ind do
                begin
                 writeln(_ars,_m:4,' ',_ou[_i+_j].nom);(*ind.de D nom.suc*)
                 for _k:=1 to _ou[_i+_j].ind do
                  begin
                   write(_ars,'   ',_k:4);
                    wr(_ou[_i+_j].il+(_m-1)*_ou[_i+_j].ind+_k-1);
                  end  (* del for _k *)
                end (* del for _m *)
              end;  (* del else *)
             if _ou[_i+_j].ind=1 then _j:=_j+1 else _bd:=false;
            end;  (*del while procesar antecesores*)

            if _ou[_i+_j].ind=1
              then _i:=_i+_ou[_i].il
               else _i:=_i+1;  (* adelantar en tabla *)

           end; (* de procesar nodo D *)
      end; (* del case  del else *)
    _i:=_i+1;

  end;  (* del while _i *)
end; (* del if nes *)

if _n_ves<>0 then
begin
 _i:=1;
 writeln(_ars); writeln(_ars);

 write
 (_ars,'Var/Ind                 Mean(t) Dev.(t)    Max.    Min. ');
  write(_ars, 'Mean(v) Dev.(v)  Actual');  writeln(_ars);

 _j:=0;
 while _i<=_n_ves do
  begin
   for _k:=1 to _ov[_i].ind do
    begin
     write(_ars,_ov[_i].nom:12);
     write(_ars,_k:3,'        ');
     _j:=_j+1;
     if _t<>0 then
     begin _vm:=_sv[_j]/_t; _d:=(_s2v[_j]-_t*_vm*_vm)/_t;
     IF _D>0 THEN _D:=SQRT(_D) ELSE _D:=0
     end
     else begin _vm:=0.0; _d:=0.0 end;
     RNCIEN(_VM); RNCIEN(_D);
     if _hv[_j]=-1.7e37 then write(_ars,'         ')
                       else  RNCIEN(_HV[_J]);
     if _lv[_j]= 1.7e37 then write(_ars,'         ')
                       else  RNCIEN(_LV[_J]);
     if _nvv[_j]<>0
     then
      begin _vm:=_svv[_j]/_nvv[_j];
       _d:=(_s2vv[_j]-_nvv[_j]*_vm*_vm)/_nvv[_j];
       if _d>0.0 then _d:=sqrt(_d) else _d:=0.0;
      end
      else begin _d:=0; _vm:=0.0 end;

     rncien(_vm); rncien(_d); rncien(_sva[_j]);
     WRITELN(_ars);
    end;_i:=_i+1
  end;
  {_ut:=readkey;   inpout._WinPause;}
end; (* del if nves *)
{Delphi 23.2.2001} if FileSize(_ars) > 0 then begin
{d95} UnMensaje('Standard Output');
{APPEND(_ARS);} WRITELN(_ARS); CLOSE(_ARS); (*TERMINAR ARCHIVO STAT*)
{dp} VerArchivoSalida(_nomars); Append(_ARS);
{Delphi 23.2.2001} end;
(*menu de estadisticas*)
 _PREMENUST;
  REPEAT
   {MENUSTAT.RETIRA; }
   {clrscr;}
   CASE SELE OF
   1:BEGIN QUIT:=TRUE;_REPI:=TRUE; END; {Delphi desactivado} (*REPETIR ESTAD*)
   2:BEGIN QUIT:=TRUE; QUIT1:=TRUE END;        (*CONTINUAR*)
   3:BEGIN _BMEN:=TRUE; QUIT:=TRUE;
      QUIT1:=TRUE;
     END;                                      (*MENU PRINCIPAL Y CONTINUAR*)
   4:BEGIN _FREQ; _PREMENUST END;              (*TABLAS FREC. Y MENUST*)
   5:BEGIN GGRAPH; _PREMENUST END; {Delphi desactivado}  (*GRAFICO Y MENUST*)
   END;
  UNTIL QUIT;  (*DE REPETIR MENUST*)
UNTIL QUIT1;   (*DE REPETIR ESTADISTICAS*)
{Delphi 10.2.2001 RefrescaGrafico;}
END; (*DEL STAT*)


(***********************************************************_MENU****)
procedure _menu; (*Menu de entrada y salida*)
var t:real;  Steach: word; s_ch: string[3];
begin
 _bmen:=false; IF _PRM THEN NREP:=1; // 30.11.2001 _nomars:='$CON1';
      title:=' ';
 if (_prm or not _rep )  and _bout
  then  (*no es disen~o Y ES PRIMERA VEZ *)  {y no es sal.suprimida}
   BEGIN
    _PREMENU;
    REPEAT  {MENUENSAL.RETIRA;}
    case SELE of
     6:BEGIN QUIT:=TRUE; _UT:='Q'; END;                (*QUIT Y SALIR*)
     2:begin                                 (*TITLE Y VOLVER A MENU*)
         {GOTOXY(24,20);
         writeln('Title up to 80 characters');
         readln(title);}
          title:=InputBox('Title of Experiment','Enter title',
                          'Basic Experiment                 ');
          _UT:='I';
         _PREMENU;
        end;
     1: begin
         _UT:='I'; GMenus.ME5.Enabled:=true;
         _inici; QUIT:=TRUE;                (*INIT Y SALIR*)
        end;
     3:begin                                          (*REPLIC Y SALIR*)
         NREP:=0; _errcod:=0;
         {GOTOXY(16,16);
         write('Number of Replications              ');
         readln(pp_buff); val(pp_buff,NTREP,errcod);
         if ntrep<1 then halt;
         gotoxy(16,18);
         write('Statistics each replication Yes/No  ');
         _ch:=upcase(readkey);}
         repeat
           pp_buff:=InputBox('Replications','Enter number:','1');
           val(pp_buff,NTREP,_errcod);
         until (_errcod=0) and (ntrep>0);

         Steach:=MessageDlg('Statistics each Replication ?',
                            mtConfirmation,[mbYes,mbNo],0);
         if Steach=6 {mrYes} then _est:=true else _est:=false;
         (*if (_ch='Y') {or (_ch='y')} then _est:=true else _est:=false;*)
         (*inicializar semillas de numeros aleatorios*)
(*Faltante de _inici 7.4.2003*)
{Delphi multig; 22.03.2001} _Windowsize:=false; _Comenzando:=true;
 _bsc:=false;
 _ut:=' ';
 if title=' ' then title:='Basic Experiment';
 (* {2001}_nomars:='$CON1';
 {d95 Pasado aqui desde STAT 1.11.00} AssignFile(_ars,_nomars); rewrite(_ars);*)
 _nftr:='$CON2';
 _outf:='$CON3';
(*Faltante de _inici 7.4.2003 fin*)
         fung.inisem;
         _inieli; _com; _rep:=true; clrstat; _init; QUIT:=TRUE;
          (*inicializar pantalla, puede ir en INIT!!!*)
        end;

     5:begin                             (*TIEMPO ADICIONAL Y SALIR*)
         if _es
          then
           begin {writeln('A option with ENDSIMUL illegal');
            _ch:=readkey;}
            inpout._ErrorDlg('A option with ENDSIMUL illegal');
            _PREMENU
           end
          else
           begin
            {write('Aditional time : '); readln(t);} _errcod:=0;
            repeat
              pp_buff:=InputBox('Aditional time','Enter:','               ');
              val(pp_buff,t,_errcod);
            until _errcod=0;
            TSIM:=TSIM+t;
            {multg 30.11.2000
            if _bgr=true then begin _bgr:=false; _gr:=true; _bpg:=true end;}

           end; QUIT:=TRUE;
      end;

     4:begin                         (*GRAFICO Y VOLVER A MENU*)
        ggraph; _PREMENU;
       end;                 (*GGRAPHIC*)
     {Delphi 24.4.2001 Se agreg opcin para Cerrar los Grficos}
     7: begin CerrarGraficos;
              _PREMENU;
        end;

    end;  (*del case*)

    UNTIL QUIT;
    {CLRSCR;}  (*SI NO ES DE SALIDA Y NO ES OPCION QUIT *)
    IF _PRM AND (SELE<>6) OR (SELE=1)
     THEN   (*LLAMAR MENU PRINCIPAL*)
     BEGIN MENU;

     (* vPRINCIPAL.MENUPORT(20,10,34,1,7{lightgray},0{black});
      GOTOXY(3,2);
      write('During Execution press  M  for Menu');
      GOTOXY(3,4); write('T for Trace/ C to Continue ');
      _ch:=upcase(readkey);
      vPRINCIPAL.MAINPORT(1 {BLUE},14 {yellow});  *)
      {d95 s_ch:=InputBox('Trace or Continue', 'Enter T or C','C');
      _ch:=s_ch[1];}
      {clrscr;}
     END;
    {gotoxy(1,15);}
   end

  else  (*disen~o de experimentos o repeticion o supr. de output*)
   begin
    if (not _rep) and not _BOUT then  (*si no es rep. ni supr. de output*)
     begin fung.inisem;                    (*inicializar semillas num.aleat*)
      _inieli;  (*crear listas en memoria dinamica*)
      _com; clrstat;
      _init;
     end;
   end
end;

(******************************************************MENU****)
procedure menu;     (*menu principal  o de ejecucion*)
var s_ch: string[3];
begin  _bmen:=false;
 {multg 30.11.2000 if _bgr=true then closegraph} ; (*quitar modo grafico*)
 _bt:=false; _QUIT:=FALSE;
 PREMENU;
 REPEAT
 {MENUPRIN.RETIRA;}
 case SELE of
 9: BEGIN QUIT:=TRUE;_quit:=true; _UT:='Q' END;
 3: begin _pexp;{_ch:=readkey;} inpout._WinPause; PREMENU end;
 2: BEGIN clrstat; QUIT:=TRUE END;
 1: BEGIN _UT:='I'; QUIT:=TRUE END;
 5: begin disfel{(true)}; PREMENU end; {MARTA se llevaron a venmenu}
 6: begin
       {write('Display or Skip statistics ');
       _ch:=upcase(readkey); }
    {d95   s_ch:=InputBox('Display or Skip Statistics','Enter D or S','D');
       _ch:=s_ch[1];}

     if MessageDlg('Display Statistics',mtConfirmation,[mbYes,mbNo],0)=6 {mrYes}
     then _est:=true else _est:=false;
      {d95 if _ch='D' then _est:=true else _est:=false;}
       QUIT:=TRUE;
      end;
 7: BEGIN venmenu.initra; QUIT:=TRUE END;
 4: BEGIN pp.stat; QUIT:=TRUE END;  //Delphi 4.6.2001 Opcion eliminada
 8:begin ggraph; PREMENU end;
 end;
 UNTIL QUIT ;
 (*marta textbackground(blue); textcolor(yellow); *)
 {clrscr;}                  (* y por si hay grafico: *)

 {multg 30.11.2000
  if _bgr=true then begin _bgr:=false; _gr:=true; _bpg:=true end;}

end;



(*******************************************************REPLIC**)
procedure replic;   (*hacer replicacion conservar num.aleat.*)
var rn1:array[1..10] of longint; i:integer;
begin  NREP:=NREP+1;
 _com;
 _init;
 clrstat;
end;

(*********************************************************TRACE****)
procedure _trace; (*ve si hay que poner o quitar trace y llama menu*)
var _tra:string[8]; x,y:byte;
begin
{
if (not _bt) and keypressed then
 begin
  _u:=upcase(readkey);
  if _u='T' then
   BEGIN clrscr; gotoxy(1,2); venmenu.initra; _U:=' ';  END;
  if _u='M' then begin menu; clrscr end
 end;
 if _bt and (upcase(_u)='T') then
  begin _u:=upcase(readkey);
   if _u='T' then
   begin clrscr;_bt:=false; menu end
  end;
 if _bt and (upcase(_u)='M') then MENU; }
 {d95}
 if OKPressed(_u,_bt) then
   if _bt then begin if _u='U' then _bt:=False;
                     {Delphi 3.6.2001} Close(_ftra);
                      VerArchivoTrazado(_nftr);
                      Append(_ftra); //Delphi 3.6.2001
                     menu;
               end
   else if _u='T' then begin venmenu.initra; _u:=' '; end
                  else menu;                  
end;
(********************************************************_EXFEL***)
procedure _exfel; (* extr. primero activo de fel *)

var ff,fa:_pfel; X,Y:BYTE; (*ff: extraido; fa: anterior*)
 begin
  if _ff=nil then
   begin {writeln('empty fel'); _ch:=readkey; }
    {Delphi 30.11.2001 inpout._WarningDlg('Empty FEL');
   menu; halt;end; }
         _error('Empty FEL');  end;

  ff:=_ff; fa:=ff;  (*buscar primer no suspendido; lo apuntara ff*)
  while ff^.su do begin fa:=ff;ff:=ff^.p end; (*fa anterior a ff*)

  if ff^.t>=time then time:=ff^.t; (*si ff fue suspendido puede tener t<time*)
  (*pasar los parametros*)
  _n:=ff^.n; iev:=ff^.i; evp:=ff^.evp;
  _tev:=ff^.t;   (*tiempo del evento; puede estar retrasado*)
  if _ff=ff
   then _ff:=_ff^.p   (*no hay susp. _ff apunta al siguiente*)
   else fa^.p:=ff^.p; (*hay, quitar el ap. por ff de la lista; _ff igual*)

  dispose(ff);

  if _bt then
   begin
   { writeln('EVENT  ',_N:3,'  IEV ',IEV:3,
    '  ********************>>>>>>>>>>>>>>       ',' TIME ',TIME:9:3);
   _ch:=readkey; inpout._WinPause;

   if _bftr then
    begin }
     writeln(_ftra,'EVENT  ',_N:3,'  IEV ',IEV:3,
    '  ******************>>>>>>>>>>>>>>         ',' TIME ',TIME:9:3);
    {d95}{Delphi 3.6.2001  Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);  }
    {d95}
    end;
  { end;}

  {Delphi 3.6.2001 if not _bt then
     begin }
      {x:=wherex; y:=wherey;
      gotoxy(1,1); }
      {writeln('    RUNNING               TIME ',TIME:10:2,
      '    REPL ',NREP:4 ); }
      AvanzaReloj(time,nrep);
      {gotoxy(x,y);}
 {Delphi 3.6.2001 end; }

end;


(********************************************************_ACT***)
procedure _act(m:integer;b:boolean); (* actual.estadisticas lista m *)
var tt,t,r,d:real;
begin
  t:=time-_hc^[m]; r:=_l^[m]; _la^[m]:=_la^[m]+t*r;_l2^[m]:=_l2^[m]+t*r*r;
  tt:=time-_tces;

  (*largo medio de lista m  y su desviacion*)
  if tt<>0 then _lp^[m]:=_la^[m]/(time-_tces) else _lp^[m]:=0.0;
  if tt<>0.0 then d:=(_l2^[m]-tt*_lp^[m]*_lp^[m])/tt else d:=0.0;
  if d<=0.0 then _de^[m]:=0.0 else _de^[m]:=sqrt(d);

  (*actualizar largo maximo lista m*)
  if b and (_l^[m]>=_lm^[m]) then _lm^[m]:=_l^[m]+1;

  if _l^[m]=0 then _tl^[m]:=_tl^[m]+t;  (*tiempo libre*)

  if _en^[m]>0  (*tiempo permanencia media en lista m y su desviacion*)
  then
   begin
    _tpp^[m]:=_tp^[m]/_en^[m]
   end
   else _tpp^[m]:=0.0;
  if _en^[m]>0 then d:=(_tp2^[m]-_en^[m]*_tpp^[m]*_tpp^[m])/_en^[m]
             else d:=0.0;
  if d<=0.0  then _dp^[m]:=0.0 else _dp^[m]:=sqrt(d);

  _hc^[m]:=time   (*hora ultimo cambio en lista m *)
 end;

(**********************************************************_AGR***)
procedure _agr(m:integer;q:_pl;p:char);
 (* agreg.el apuntado por _pl, a listai m, posi.p ;
    pone nil si es ultimo; ajusta ET a TIME; ajusta lm y en*)
var pt:_pfrg ;
begin
 _swt:=false;
 if _fl[m]=nil
 then begin _fl[m]:=q;_ll[m]:=q; q^.p:=nil end
 else case p of
       'l':begin _ll[m]^.p:=q; q^.p:=nil; _ll[m]:=q end;
       'f':begin q^.p:=_fl[m]; _fl[m]:=q end;
      end;
 _act(m,true);
(*d95  pt:=ptr(q^.b,q^.d);*)
 pt:=q^.b;
 pt^.ET:=time; ET:=TIME;
 if _bt then
   writeln(_FTRA,'ADD MESS.#',Q^.NUMBER:5,' GEN ',Q^.NOR:12,
      ' TO   ',_TNL[M]:15, ' LL ', _l^[m]:5,' TIME ',TIME:9:3);

      _l^[m]:=_l^[m]+1; _en^[m]:=_en^[m]+1;
if _bt then
begin
  writeln(_FTRA,_en^[m],'*****XXXX*************');
    (*Delphi 3.6.2001
    {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95}  *)
end;
end;

(*****************************************************_INTER**)
procedure _inter(m:integer;_px,_pa,_pu:_pl);
(* intercalar el apuntado por _px de lista m entre  _pa,,_pu *)
(*_pa o _pu pueden ser nil*)
var pt:_pfrg;
begin
  if _pa=nil then _fl[m]:=_px else _pa^.p:=_px; _px^.p:=_pu;
(*d95  pt:=ptr(_px^.b,_px^.d); pt^.ET:=time;*)
 pt:=_px^.b; pt^.ET:=time;
 if _bt then

  begin
   writeln(_ftra,'INT.MESS.#',_px^.NUMBER:5,' GEN ',NODE:12,
      ' TO ',_TNL[M]:15, ' LENGTH ', _l^[m]:5,' TIME ',TIME:9:3);
  {end;
   _ch:=readkey _WinPause; }
   (*Delphi 3.6.2001
   {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95}  *)
  end;  
 _act(m,true); _l^[m]:=_l^[m]+1; _en^[m]:=_en^[m]+1
end;

(*********************************************************_EXAL**)
procedure _exal(q:_pl);(* exam. de listai ap.por q;apun.p al sig.*)
var pt:_pfrg;
begin if q=nil then _error('Examined Message list empty')
 else
  begin
   _r:=q^.r; _b:=q^.b; {d95 _d:=q^.d;}
   pt:=_b; ET:=pt^.et; XT:=pt^.xt;
   _p:=q^.p;
   number:=q^.number; node:=q^.nor;
   if _bt then
      begin
       writeln(_ftra,'EXA.MESS.#',q^.NUMBER:5,' GEN ',NODE:12);
       (*Delphi 3.6.2001
    {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95} *)  
    end;
  end
end;

(*******************************************************_EXALO**)
procedure _exalo(q:_pl);(* exam. de listai ap.por q;apun.p al sig.*)
var pt:_pfrg;
begin if q=nil then _error('Examined O_Messages list empty')
 else
  begin
   _or:=q^.r; _ob:=q^.b; {d95 _od:=q^.d;}
   pt:=_ob; O_ET:=pt^.et; O_XT:=pt^.xt;
   o_number:=q^.number; o_node:=q^.nor; {CARLOS 5.7.96}
   _op:=q^.p;
  end
end;

(*******************************************************_EXTR***)
procedure _extr(var q:_pl;m:integer);(* extr.de listai m,ap.por q *)
var pt:_pfrg ; tx:real; _t:_pl;
begin _swt:=false;
  {d95 pt:=ptr(q^.b,q^.d);} pt:=q^.b;  number:=q^.number; node:=q^.nor;
 if _bt then

      begin
       writeln(_ftra,'EXT.MESS.#',Q^.NUMBER:5,' GEN ',NODE:12,
       ' FROM ',_TNL[M]:15, ' LL ', _l^[m]:5,' TIME ',TIME:9:3);
     {end;
   _ch:=readkey; _WinPause; }
   (*Delphi 3.6.2001
   {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95} *) 
  end;
 if _fl[m]=nil then _error('List to extract empty');
 if _fl[m]^.p=nil (* hay uno solo *)
  then begin q:=_fl[m]; _fl[m]:=nil; _ll[m]:=nil end
  else if q=_fl[m] then _fl[m]:=q^.p  (* es el primero *)
                   else  (* hay que buscar el anterior *)
                    begin  _t:=_fl[m];
                     while _t<>q do
                      begin _pa:=_t;_t:=_t^.p;
                       IF _T=NIL THEN _ERROR('no message to send');
                      end;
                     _pa^.p:=_t^.p; if q=_ll[m] then _ll[m]:=_pa;
                    end;
 _act(m,false); _l^[m]:=_l^[m]-1;
 tx:=time-pt^.ET; _tp^[m]:=_tp^[m]+tx; _tp2^[m]:=_tp2^[m]+tx*tx;
 if tx>_mtp^[m] then _mtp^[m]:=tx;
end;

(******************************************************_TRAN**)
procedure _tran(bex:boolean; m,n:integer; p:char; apor,apde:_pl);
(* extrae el de lista m apuntado por apor (si bex true) y pone en
pos. p de lista n apuntado por apde
Si se indica extraer y es m=0 se trata de lista de ensamblados
y es necesario hacer la extraccion aparte*)
var pac,pan,pg,pa,apor1,_UFA:_pl; pt:_pfrg;
begin
(*extraer un ensamblado*)
if (m=0) and bex then (*lista de ensamblados. Extraer el ap. por _pu*)
 begin          (*poner apor en vez de _pu*)
  pg:=_px^.pas;  (*desde _px.pas buscar anterior al apunt. por _pu *)
  pa:=pg;
  while pg<>_pu do begin pa:=pg; pg:=pg^.p end;
  if pg=_px^.pas then
   BEGIN _px^.pas:=PG^.P;_PAS:=PG^.P END (*si ES EL PRIMERO*)
   ELSE BEGIN pa^.p:=_pu^.p; _PAS:=PA^.P END;(*conec anterior al sig*)

  if  _bt then     (*trazado*)
  begin
    pt:=_pu^.b;
    write(_ftra,'EXT.MESS. GT ',PT^.GT:9:2,'  FROM ASSEMBLE LIST');
    writeln(_ftra,_c08,'TIME ',TIME:9:2);
   {end;
   _ch:=readkey _WinPause; }
   (*Delphi 3.6.2001 {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95} *)
  end;  
  (*falta enviar el extraido a su destino*)


 end;          (*fin de envio de ensamblado*)

 if bex and (m<>0) then
  begin
   apor1:=apor^.p;
   _extr(apor,m);  (* extraer del origen:apor,lista m; act.estad.*)

     if _bsc then
   begin {MARTA .98}
     _pu:=apor1; (*si es SCAN o EXTR apuntar
                                      _pu al que sigue*) {1998}
     if _pu<>nil then
     begin {Pasar variable del siguiente a O_variable}
       _uprvo(_pu^.r,_pu^.b);
       O_PMESS:=_pu;
       _exalo(_pu);
     end;
   end;
  end;

(*agregado del extraido o del apuntado por apor*)

 if (_fl[n]=apde) and (p='B') (*agregar antes que el primero*)
  then
   begin
    _agr(n,apor,'f');     (* agregar comienzo act.estad*)


    if bex and (apor^.p<>nil)  (*si se extrajo y se agrego y hay sig.*)
     then
      begin
(******************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!***********)
     if apor=_px then _px:=apor1 else if apor=_pu then _pu:=apor1;
      end
   end
   else
    if (_ll[n]=apde) and (p='A')  (*agregar despues del ultimo*)
     then
      BEGIN
       _agr(n,apor,'l');   (* agregar final act.estad*)
      END

     else     (*apde es un apuntador*)
      begin

   { WRITELN('PASS3'); _CH:=READKEY;}

       if p='A'  (*agregar despues del apuntado*)
        then begin apor^.p:=apde^.p; apde^.p:=apor end
        else     (*agregar antes del apuntado*)
         begin
          pac:=_fl[n]; pan:=pac;
                  { }
{ WRITELN('EXTRAJO ENSAMBLADO'); _CH:=READKEY; }
          while (pac<>nil) and (pac<>apde) do
           begin pan:=pac; pac:=pac^.p end;
          apor^.p:=pan^.p; pan^.p:=apor;
         end;

        _swt:=false;

        {d95 pt:=ptr(apor^.b,apor^.d);} pt:=apor^.b;
{}
        if _bt then
         {begin
          writeln('ADD MESS.#',APOR^.NUMBER:5,' GEN ',APOR^.NOR:12,
          ' TO   ',_TNL[N]:15, ' LL ', _l^[N]:5,' TIME ',TIME:9:3);

          if _bftr then     }
           begin
         writeln(_FTRA,'ADD MESS.#',APOR^.NUMBER:5,' GEN ',APOR^.NOR:12,
         ' TO   ',_TNL[N]:15, ' LL ', _l^[N]:5,' TIME ',TIME:9:3);
           {end;
           _ch:=readkey _WinPause;}
          (*Delphi 3.6.2001  {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra); 
    {d95} *)
         end;  

        _act(n,true);
         pt^.ET:=time;  ET:=TIME;  (*actualiza tiempo de entrada*)
        _l^[n]:=_l^[n]+1; _en^[n]:=_en^[n]+1

      end

end;
 (****************************************************_EXLX*************)
procedure _exlx(var q:_pl; m:integer); (*busca en IL de nodo R*)
var p:_pl; pt:_pfrg;
begin
 if _bt then
  {begin
   writeln('EXAM.LIST ',_TNL[M],' SEEK EXIT TIME ',_TEV:9:3);
   if _bftr then }
    begin writeln(_ftra,'EXAM.LIST ',_TNL[M],' SEEK EXIT TIME ',_TEV:9:3);
   {end;
  _ch:=readkey _WinPause;}
  (*Delphi 3.6.2001 {d95} Close(_ftra);
          VerArchivoTrazado(_nftr);
          Append(_ftra);
    {d95} *)
  end;  
 q:=_fl[m];_bo:=true;
 while (q<>nil) and _bo do
   begin {d95 pt:=ptr(q^.b,q^.d);} pt:=q^.b;
   if pt^.XT=_tev then _bo :=false; p:=q; q:=q^.p end;
 q:=p; if _bo then _error('no register with EX=time')
end;

(********************************************* _COPY******)
procedure _copy(p:_pl;m:integer;aob:char;apdes:_pl);
{_copy(p:_pl;m:integer);}(* copia reg.e indic. y env. a m AoB apdes*)
 begin _newr(p^.r,_b); new(_pp); _pp^.r:=p^.r;
  _pp^.b:=_b; {d95_pp^.d:=_d;} _pp^.number:=p^.number; _pp^.nor:=p^.nor;
 {_agr(m,_pp,'l')} _tran(false,0,m,aob,_pp,apdes); end;

(******************************************************_SINC***)
procedure _sinc(m,n:integer); (* hace lista sincr.por cond.log.n  *)
                              (* busca hasta m o nil              *)
 begin

IF _BT THEN
  {begin
   WRITELN('SEEK TO SYNCHRO ',M,' WITH CONDITION ',N);
   IF _BFTR THEN  }
    WRITELN(_ftra,'SEEK TO SYNCHRO ',M,' WITH CONDITION ',N);
  {end; }

 _exal(_pu); _uprv(_r,_b);
 _ks:=1; new(_fs); _fs^.p1:=_pu; _fs^.p2:=nil; _as:=_fs;
  _psi:=_pu^.p; (* _psi apunta a primero a comparar *)
  while (_psi<>nil) and (_ks<m) do begin
  _exalo(_psi);
  _uprvo(_or,_ob);
  if _cl(n) then  (* ver condicion logica n *)
   begin
    new(_pc);_pc^.p1:=_psi; _ks:=_ks+1;_pc^.p2:=nil;
   _as^.p2:=_pc; _as:=_pc
   end;
   _psi:=_psi^.p  (* ir a comparar con el siguiente *)
  end;
  _sf:=true;
IF _BT THEN
 {BEGIN
  WRITELN(_KS,' RECORDS SYNCHRONIZED');
IF _BFTR THEN  }
  WRITELN(_ftra,_KS,' RECORDS SYNCHRONIZED')   {  END;}
 end;

(*****************************************************TAB******)
procedure tab(x:real;j:integer); (*suma 1 al inter.de clase,  tabl. j *)
var cl:real; b:boolean; i,k:integer;
begin b:=true; i:=1; cl:=_df[j,1]; k:=trunc(_df[j,2]);
while b and (i<k) do
 if x<cl then b:=false
         else begin cl:=cl+_df[j,3]; i:=i+1 end;
_fr[j,i]:=_fr[j,i]+1
end;
(****************************************************_EUL***)
procedure _eul(m,n:integer);  (*Euler*)
var iec:integer; _a:_arrv;
begin
 for iec:=m to n do _a[iec-m+1]:=_dt*_fec(time,iec);
 for iec:=m to n do  _y[_ore[iec]]:=_y[_ore[iec]]+_a[iec-m+1];
end;

(*******************************************************_RK4**)
procedure _rk4(m,n:integer);  (*Runge-Kutta de orden 4, paso fijo*)
var a:_ARRM; i,j,k,iec,iecm,iea:integer; CH:CHAR;
 z:_ARRV;
const c:array[1..3] of real=
 (0.5,0.5,1.0);
  dti:array[1..3] of real=(0.5,0.5,1.0);

begin
 for iec:=m to n do z[_ore[iec]]:=_y[_ore[iec]];
 (*guar.en z val.inic.de var a cambiar*)

 for iec:=m to n do a[1,iec-m+1]:=_dt*_fec(time,iec);

 for i:=2 to 4 do  (*calcular a[2,iec-m+1] a[3,iec-m+1], etc*)
 begin
  for iec:=m to n do
   _y[_ore[iec]]:=z[_ore[iec]]; (*val. inic.-> a las var.a cambiar*)

  for iec:=m to n do
   _y[_ore[iec]]:=_y[_ore[iec]]+a[i-1,iec-m+1]*c[i-1];
  for iec:=m to n do
   a[i,iec-m+1]:=_dt*_fec(time+dti[i-1]*_dt,iec);
 end;

 for iec:=m to n do
  begin iea:=iec-m+1;
   _y[_ore[iec]]:=z[_ore[iec]]+(a[1,iea]+2.0*a[2,iea]
                 +2.0*a[3,iea]+a[4,iea])/6.0;
  end;

end;

(******************************************************_RKF**)
procedure _rkf(m,n:integer);  (*Runge-Kutta-Fehlberg*)
var a:_ARRM; i,j,k,iec,iecm,iea:integer;        KL:INTEGER;
 z,error:_ARRV;
 err,q,ym:real; cont:boolean;
const c:array[1..15] of real=
 (0.25,0.09375,0.28125,0.8793809,-3.2771962,3.3208921,2.0324074,
 -8.0,7.1734893,-0.2058966,-0.296296296,2.0,-1.3816764,0.4529727,-0.275);
  dti:array[1..6] of real=(0.0,0.25,0.375,0.9230769,1.0,0.5);

begin

 for iec:=m to n do z[_ore[iec]]:=_y[_ore[iec]];
 (*guar.en z val.inic.de var a cambiar*)

 repeat  (* repetir hasta error maximo del paso <errp *)
 cont:=true;
 for iec:=m to n do a[1,iec-m+1]:=_dt*_fec(time,iec);
 k:=0;
 for i:=1 to 6 do
 begin  k:=k+i-2;
  for iec:=m to n do
   _y[_ore[iec]]:=z[_ore[iec]]; (*val. inic.-> a las var.a cambiar*)
  for j:=2 to i do
    for iec:=m to n do
     _y[_ore[iec]]:=_y[_ore[iec]]+a[j-1,iec-m+1]*c[j+k];
  for iec:=m to n do
   a[i,iec-m+1]:=_dt*_fec(time+dti[i]*_dt,iec);
 end;

 err:=0.0;               (******!!!!!!!!REVISAR****************)
 for iec:=m to n do
  begin iea:=iec-m+1;
   error[iea]:=0.002777777*a[1,iea]-0.0299415*a[3,iea]-0.0291998*a[4,iea]
     +0.02*a[5,iea]+0.036363636*a[6,iea];
   if abs(error[iea])>=err then begin err:=abs(error[iea]); iecm:=iea end;
  end;

   ym:=_y[_ore[iecm]]+0.1157407*a[1,iecm]+0.5489278*a[3,iecm]
                 +0.5353313*a[4,iecm]-0.2*a[5,iecm];
  q:=err/(eabs+erel*abs(ym))+1;
 if q>1.1 then
 begin _dt:=_dt/(sqrt(sqrt(q)));
  cont:=false;
  for iec:=m to n do _y[_ore[iec]]:=z[_ore[iec]]; (*val. inic.-> a las var.a cambiar*)
 end;
 if q<0.5 then   (*OJO SE PUSO /  EN VEZ DE *  *)
 begin _dt:=_dt/(sqrt(sqrt(q)))  ; {write(' q=',q:7:2,' aume. '); }
_dta:=_dt;
 end;

 until cont;

 for iec:=m to n do
  begin iea:=iec-m+1;
   _y[_ore[iec]]:=z[_ore[iec]]+0.1157407*a[1,iea]+0.5489278*a[3,iea]
                 +0.5353313*a[4,iea]-0.2*a[5,iea];
  end;
end;

procedure _sort(m:integer; var x,o_x:real; c:char);
var p,pf,pa,paa,pr,pl,puc:_pl; hc:boolean;
begin
 pf:=_fl[m]; pl:=nil; hc:=true;
 if (pf<>nil) and (pf^.p<>nil) then
 begin
 while hc do
 begin
  pa:=pf; p:=pa^.p; paa:=pa;  hc:=false;

  while p<>pl do
  begin
 _uprv(p^.r,p^.b);      (* actual   *)
 _uprvo(pa^.r,pa^.b);  (* anterior *)
   if (x>o_x)<>(c='A')
    then
     begin (* reordenar si crec. y x>o_x o bien si decr. y x<=o-x *)

      paa^.p:=p; pa^.p:=p^.p; p^.p:=pa;
      if pa=pf then begin _fl[m]:=p; pf:=p end;
      pr:=p; p:=pa; pa:=pr ; puc:=p ; hc:=true;
      if p^.p=nil then _ll[m]:=p;
     end;
    paa:=pa; pa:=p; p:=p^.p;
  end;

  pl:=puc
 end
 end
end;   (*SORT*)

END.